TITLE  Keyboard Routines
SUBTTL Copyright (c)1989 Ross Neilson Wentworth, All Rights Reserved

.MODEL TPASCAL
.CODE
LOCALS @@

PUBLIC ReadWord,ReadATWord,SetKeyboard,FoldKey,FlushKey,PeekKey

f_adjust DB     0

ReadWord PROC   FAR

         xor    ah,ah
         int    16h
         ret

ReadWord ENDP

ReadATWord PROC FAR

         mov    ah,cs:[f_adjust]
         int    16h
         ret

ReadATWord ENDP

SetKeyboard PROC NEAR

         xor    ax,ax
         mov    cs:[f_adjust],al
         mov    es,ax
         test   byte ptr es:[0496h],10h
         jz     @@01
         mov    al,10h
         mov    cs:[f_adjust],al
@@01:
         ret

SetKeyboard ENDP

comment /
SetKeyboard PROC NEAR

         mov    cs:[f_adjust],0
         mov    ah,05h
         mov    cx,0FFFFh
         int    16h
         mov    ah,11h
         int    16h
         cmp    ax,0FFFFh
         jnz    @@1
         mov    ah,10h
         int    16h
         mov    cs:[f_adjust],10h
@@1:
         ret

SetKeyboard ENDP
/
FoldKey PROC    FAR

        xor     ah,ah
        int     16h
        or      al,al
        jnz     @@01
        mov     al,ah
        or      al,80h
@@01:
        ret

FoldKey ENDP

FlushKey PROC   FAR

@@11:
        mov     ah,1
        int     16h
        jz      @@12
        xor     ah,ah
        int     16h
        jmp     short @@11
@@12:
        ret

FlushKey ENDP

PeekKey PROC    FAR

        mov     ah,1
        int     16h
        jnz     @@21
        xor     ax,ax
@@21:
        ret

PeekKey ENDP

END
