{ Copyright (c)1989 Ross Neilson Wentworth, All Rights Reserved }
{$A+,B-,D+,E+,F-,I+,L+,N+,O-,R-,S-,V-}
Unit Keyboard;

Interface

Uses CRT;

Const
  On  = TRUE;
  Off = FALSE;

Function ReadWord : Word;

Function ReadATWord : Word;

Function FoldKey : Byte;

Procedure FlushKey;

Function PeekKey : Word;

Procedure Noise(State : Boolean);

Procedure Sound(Hz : Word);

Implementation

Var
  SoundFlag : Boolean;

Function ReadWord : Word; External;

Function ReadATWord : Word; External;

Function FoldKey : Byte; External;

Procedure FlushKey; External;

Function PeekKey : Word; External;

Procedure SetKeyboard; External;

{$L keyboard.obj}

(**********************************************************************)

Procedure Noise(State : Boolean);

Begin
  SoundFlag := State;
End;

Procedure Sound(Hz : Word);

Begin
  If SoundFlag Then CRT.Sound(Hz);
End;

Begin
  SoundFlag := TRUE;
  FlushKey;
  Setkeyboard;
End.

