{$A-,B-,D+,E+,F-,I+,L+,N-,O-,R-,S-,V-}
{$M 1024,2048,2048}
Program PopUpDice;

Uses Crt,           { use the BIOS for video - REQUIRED }
     Dice,          { dice rolling main unit            }
     PopUp;         { low-level popup control routines  }

Type
  String7 = String[7];

Const
  Version   = '1.0';
  Signature : String7 = 'PopDice';
  IdNumber  = $89;                      { must be greater than $80 }
  Hotkey    = Alt + LeftShift + $20;    { default hot key          }

Var
  ErrorCode   : Byte;

Procedure Copyright;

Begin
  WriteLn;
  WriteLn('PopDice Version ',Version,' (c) Copyright 1988 Ross Neilson Wentworth');
  WriteLn;
End;

Begin
  Copyright;                                  { display my name          }
  ErrorCode := Installed(Signature,IDNumber); { see if we can install    }
  If ErrorCode <> 0 Then
  Begin                                       { already or can't install }
    Write('ERROR!  ');
    Case ErrorCode Of
      1 : WriteLn('This program must be loaded before PRINT.COM.');
      2 : WriteLn('I.D. number already in use.');
      3 : WriteLn('Program is already installed.');
      4 : WriteLn('Internal error, can''t install.');
    End;
    Halt(ErrorCode);                          { return an error code     }
  End;
  WriteLn('Press ALT + LeftShift + D to activate');
  StayResident(IdNumber,@Popdice,Nil,Hotkey,0);
End.
